unit etude_u;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Imaging.PNGImage, System.Math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Dclarations prives }
    FBufferBackground: TBitmap;
    FBuffer: TBitmap;
    FTop: integer;
    FImageCaseVide, FImagePionBlanc, FImagePionNoir: TPNGImage;
    Dropping: boolean;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  MARGE = 10;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Dropping := TRUE;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FBufferBackground := TBitmap.Create;
  FBufferBackground.PixelFormat := pf32Bit;
  FBufferBackground.Width := 40;
  FBufferBackground.Height := 280;

  FBuffer := TBitmap.Create;
  FBuffer.PixelFormat := pf32Bit;
  FBuffer.Width := 280;
  FBuffer.Height := 280;

  FImageCaseVide := TPNGImage.Create;
  FImagePionBlanc := TPNGImage.Create;
  FImagePionNoir := TPNGImage.Create;

  FImageCaseVide.LoadFromFile('.\images\empty.png');
  FImagePionBlanc.LoadFromFile('.\images\white.png');
  FImagePionNoir.LoadFromFile('.\images\black.png');

  with FBufferBackground.Canvas do
  begin
    Brush.Color := $707070;
    FillRect(Rect(0, 0, FBufferBackground.Width, FBufferBackground.Height));
    for i := 1 to 6 do
      Draw(0, 40 * i, FImageCaseVide);
  end;

  for i := 0 to 6 do
    FBuffer.Canvas.Draw(40 * i, 0, FBufferBackground);

  //Canvas.Draw(MARGE, MARGE, FBuffer);

  FTop := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBufferBackground.Free;
  FBuffer.Free;
  FImageCaseVide.Free;
  FImagePionBlanc.Free;
  FImagePionNoir.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
const
  STEP = 1;
var
  vRect1, vRect2: TRect;
begin
  if Dropping then
  begin
    vRect1 := Rect(0, Max(FTop - STEP, 0), 40, FTop + 20);
    FBuffer.Canvas.CopyRect(vRect1, FBufferBackground.Canvas, vRect1);
    FBuffer.Canvas.Draw(0, FTop, FImagePionBlanc);

    //vRect1 := Rect(vRect1.Left, vRect1.Top, vRect1.Right, vRect1.Bottom + 20);
    //vRect2 := Rect(vRect1.Left + MARGE, vRect1.Top + MARGE, vRect1.Right + MARGE, vRect1.Bottom + MARGE);
    //Canvas.CopyRect(vRect2, FBuffer.Canvas, vRect1);

    Canvas.Draw(MARGE, MARGE, FBuffer);

    if FTop = 240 then
    begin
      Dropping := FALSE;
      FTop := 0;
    end else
    begin
      //Invalidate;
      InvalidateRect(Handle, nil, FALSE);
      //InvalidateRect(Handle, vRect2, FALSE);
      Sleep(1);
      Inc(FTop, STEP);
    end;
  end;
end;

end.
